program RSSUtil;

uses Windows, messages, graphics, sysutils, math, commctrl, ShellApi, RSSUtils;
  
{$R RSSUtil.res}

const OFN_EXPLORER = $00080000;
      OFN_NONETWORKBUTTON = $00020000;
      OFN_HIDEREADONLY = $00000004;
      //    
      b1x=9; b1y=7; b1w=55; b1h=25;     //open
      b2x=72; b2y=7; b2w=55; b2h=25;    //save
      b3x=9; b3y=313; b3w=118; b3h=25;  //process

      l1x=12; l1y=44; l1w=40; l1h=15;   //angle
      l2x=9;  l2y=343; l2w=125; l2h=26; //time
      l3x=12; l3y=98; l3w=100; l3h=15;  //color
      l5x=12; l5y=118; l5w=20; l5h=15;  //Fon R
      l6x=12; l6y=136; l6w=20; l6h=15;  //Fon G
      l7x=13; l7y=154; l7w=20; l7h=15;  //Fon B
      l8x=12; l8y=180; l8w=50; l8h=15;  //Centre X
      l9x=12; l9y=198; l9w=50; l9h=15;  //Centre Y
      l10x=16; l10y=225; l10w=49; l10h=15;  //Scale X
      l11x=16; l11y=243; l11w=49; l11h=15;  //Scale Y
      l12x=22; l12y=270; l12w=40; l12h=15;  //ShiftX
      l13x=22; l13y=288; l13w=40; l13h=15;  //ShiftY

      e1x=55; e1y=44; e1w=71; e1h=15;   //angle
      e2x=35; e2y=118; e2w=21; e2h=15;  //R
      e3x=35; e3y=136; e3w=21; e3h=15;  //G
      e4x=35; e4y=154; e4w=21; e4h=15;  //B
      e5x=66; e5y=180; e5w=60; e5h=15;  //Centre X
      e6x=66; e6y=198; e6w=60; e6h=15;  //Centre Y
      e7x=66; e7y=225; e7w=60; e7h=15;  //Scale X
      e8x=66; e8y=243; e8w=60; e8h=15;  //Scale Y
      
      e9x=66; e9y=270; e9w=60; e9h=15;  //ShiftX
      e10x=66; e10y=288; e10w=60; e10h=15;  //ShiftY

      c1x=11; c1y=69; c1w=40; c1h=20;   //CW
      c2x=57; c2y=69; c2w=45; c2h=20;   //CCW

      otX=138; //     
      otY=5;

type
 tagOFNA = packed record
  lStructSize: DWORD;
  hWndOwner: HWND;
  hInstance: HINST;
  lpstrFilter: PAnsiChar;
  lpstrCustomFilter: PAnsiChar;
  nMaxCustFilter: DWORD;
  nFilterIndex: DWORD;
  lpstrFile: PAnsiChar;
  nMaxFile: DWORD;
  lpstrFileTitle: PAnsiChar;
  nMaxFileTitle: DWORD;
  lpstrInitialDir: PAnsiChar;
  lpstrTitle: PAnsiChar;
  Flags: DWORD;
  nFileOffset: Word;
  nFileExtension: Word;
  lpstrDefExt: PAnsiChar;
  lCustData: LPARAM;
  lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
  lpTemplateName: PAnsiChar;
 end;

var
  MainWND, hFontBold: thandle;
  but1,but2,but3,ed1,ed2,ed3,ed4,ed5,ed6,ed7,ed8,ed9,ed10,l1,l2,l3,l5,l6,l7,l8,l9,l10,l11,l12,l13,ch1,ch2:THandle;
  WC:TWndClass;
  Mesg:TMsg;
  sour,resb,res2b: tbitmap;
  FinBit:pbit;
  grt:trect;
  Thr:longword;
  ofn:tagOFNA;
  oFilterIndex:DWORD;
  origin:boolean=true;
  init:boolean=false;
  CX,CY,ugol,delt,ShX,ShY,SclX,SclY: extended;
  t1,t2,t3:int64;
  picW,picH,FonR,FonG,FonB:integer;
  tgAd2,tgBd2,sinB,cosB,sinBucosBd2,cosAu2,cosBu2,triS,pdx,pdy:extended;

function GetOpenFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll' name 'GetOpenFileNameA';
function GetSaveFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll' name 'GetSaveFileNameA';

function GetCaption(wnd:Thandle):string;
begin
 setlength(result,255);
 setlength(result,getwindowtext(wnd,pchar(result),255));
end;

function DoMax(x:extended):integer;
begin
 if x<0 then if frac(abs(x))>1e-9 then result:=trunc(x)-1 else result:=trunc(x)
        else if frac(x)>1e-9 then result:=trunc(x)+1 else result:=trunc(x);
end;

procedure CalcProc;
 var inB,outB:pbit;
 trigger:boolean;
begin
 queryperformancecounter(t1);

 trigger:=false; // 
 if (SclX<>1)or(SclY<>1) then begin
  ScalePic(@sour,@resb,SclX,SclY,FonR,FonG,FonB);
  inB:=@resb;
  outB:=@res2b;
  trigger:=true; //
 end else begin //   
  inB:=@sour;
  outB:=@resb;
 end;

 if ugol>=360 then ugol:=ugol-360*trunc(ugol/360); //  360
 if ugol<>0 then begin
  if sendmessage(ch2,BM_GETSTATE,0,0)=BST_CHECKED then ugol:=360-ugol;  // "  "   " "
  RotatePic(inB,outB,ugol,CX,CY,FonR,FonG,FonB);
  inB:=outB;
  if trigger then outB:=@resb else outB:=@res2b;
 end;
 
 if (ShX=0)and(ShY=0) then outB:=inB
                      else ShiftPic(inB, outB,Shx, ShY,FonR,FonG,FonB);
                      
 FinBit:=outB;
 origin:=false;
 queryperformancecounter(t2);
 queryperformancefrequency(t3);
 setwindowtext(l2,pchar('Calculation time (sec): '+#10+#13+floattostr((t2-t1)/t3)));
 enablewindow(but1,true);
 enablewindow(but2,true);
 enablewindow(but3,true);
 sendmessage(mainwnd,WM_SIZE,0,0); // 
end;

procedure LoadPic(FileName:string);
 var ext:string;
begin
 ext:=ExtractFileExt(FileName);
 ext:=LowerCase(ext);
 if ext='.bmp' then begin
  sour.LoadFromFile(filename);
 end else begin
  messagebox(mainwnd,'This is not BMP-file','Error',MB_OK or MB_ICONEXCLAMATION);
  exit;
 end;
 sour.PixelFormat:=pf24bit;
 SetWindowText(mainwnd,pchar(' RSSUtil: '+filename+'  ['+inttostr(sour.Width)+'x'+inttostr(sour.Height)+']'));
 setwindowtext(l2,pchar('Calculation time (sec): '+#10+#13+'0'));
 enablewindow(but3,true);
 enablewindow(but2,false);
 origin:=true;
 init:=true; //  
 sendmessage(mainwnd,WM_SIZE,0,0);
end;

procedure OpenPic;
 var FileBuf:string;
begin
 FileBuf:=StringOfChar(#0, 26000);
 ofn.hWndOwner:=MainWnd;
 ofn.lpstrFilter:='Bitmap image (*.bmp)'+#0+'*.bmp'+#0+#0;;
 ofn.nFilterIndex:=oFilterIndex;
 ofn.lpstrFile:=PChar(FileBuf);
 ofn.nMaxFile:=Length(FileBuf);
 ofn.lpstrInitialDir:=nil;
 ofn.lpstrTitle:='Open image for processing';
 ofn.Flags:=OFN_EXPLORER or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON;
 ofn.lStructSize:=SizeOf(ofn);
 if GetOpenFileName(ofn) then LoadPic(ofn.lpstrFile);
end;

procedure SavePic;
 var filname,FileBuf:string;
begin
 FileBuf:=StringOfChar(#0, 26000);
 ofn.hWndOwner:=MainWnd;
 ofn.lpstrFilter:='Bitmap image (*.bmp)'+#0+'*.bmp'+#0+#0;;
 ofn.nFilterIndex:=oFilterIndex;
 ofn.lpstrFile:=PChar(FileBuf);
 ofn.nMaxFile:=Length(FileBuf);
 ofn.lpstrInitialDir:=nil;
 ofn.lpstrTitle:='Save the processed image';
 ofn.Flags:=OFN_EXPLORER or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON;
 ofn.lStructSize:=SizeOf(ofn);
 if GetSaveFileName(ofn) then begin
  filname:=ChangeFileExt(ofn.lpstrFile,'')+'.bmp';
  if FileExists(filname) then
  if messagebox(mainwnd,pchar('File "'+Extractfilename(filname)+'" already exists. Rewrite?'),'Question',MB_YESNO or MB_ICONQUESTION)=7 then exit;
  FinBit^.SaveToFile(filname);
 end;
end;

function GetCorrectNumber(var x:extended; c:thandle; str:string; otr:boolean):boolean;
var ch:char;
    s:string;
begin
 if decimalseparator=',' then ch:='.' else ch:=','; //      
 s:=GetCaption(c);
 if pos(ch,s)<>0 then begin
  s[pos(ch,s)]:=decimalseparator;
  SetWindowText(c,pchar(s));
 end;
 try
  x:=strtofloat(s);
  if otr=false then begin //   
   x:=abs(x);
   SetWindowText(c,pchar(floattostr(x)));
  end;
 except
  on EConvertError do begin
   messagebox(mainwnd,pchar(str),'Error',MB_OK or MB_ICONEXCLAMATION);
   result:=false;
   exit;
  end;
 end;
 result:=true; 
end;

function WindowProc(Wnd:HWND; Msg:Integer; wParam:wParam; lParam:lParam):Longint; stdcall;
 var PST:PAINTSTRUCT;
     d1:hdc;
     R:trect;
     buffer:array[0..255] of char;
begin
 Result:=0;
 case Msg of
  WM_COMMAND:if HIWORD(wParam)=BN_CLICKED then begin
   if cardinal(lparam)=but1 then OpenPic;  // Open

   if cardinal(lparam)=but2 then SavePic;  // Save

   if cardinal(lparam)=but3 then begin     // Process

    if GetCorrectNumber(ugol,ed1,'Enter a valid angle value',false)=false then exit;
    if GetCorrectNumber(CX,ed5,'Enter a valid centre X value',true)=false then exit;
    if GetCorrectNumber(CY,ed6,'Enter a valid centre Y value',true)=false then exit;
    if GetCorrectNumber(SclX,ed7,'Enter a valid scale X value',false)=false then exit;
    if SclX=0 then begin SclX:=1; SetWindowText(ed7,'1'); end;
    if GetCorrectNumber(SclY,ed8,'Enter a valid scale Y value',false)=false then exit;
    if SclY=0 then begin SclY:=1; SetWindowText(ed8,'1'); end;
    if GetCorrectNumber(ShX,ed9,'Enter a valid shift X value',true)=false then exit;
    if GetCorrectNumber(ShY,ed10,'Enter a valid shift Y value',true)=false then exit;
    FonR:=strtoint(GetCaption(ed2));
    FonG:=strtoint(GetCaption(ed3));
    FonB:=strtoint(GetCaption(ed4));
    if (FonR>255)or(FonR<0) then begin FonR:=255; setwindowtext(ed2,'255'); end;
    if (FonG>255)or(FonG<0) then begin FonG:=255; setwindowtext(ed3,'255'); end;
    if (FonB>255)or(FonB<0) then begin FonB:=255; setwindowtext(ed4,'255'); end;
    enablewindow(but1,false);
    enablewindow(but2,false);
    enablewindow(but3,false);
    CreateThread(nil,0,@CalcProc,nil,0,Thr); //   
   end;

   if cardinal(lparam)=ch1 then begin          //radiobutton  1
    SendMessage(ch1,BM_SETCHECK,BST_CHECKED,0);
    SendMessage(ch2,BM_SETCHECK,BST_UNCHECKED,0);
   end;

   if cardinal(lparam)=ch2 then begin          //radiobutton  2
    SendMessage(ch1,BM_SETCHECK,BST_UNCHECKED,0);
    SendMessage(ch2,BM_SETCHECK,BST_CHECKED,0);
   end;     
  end else Result:=DefWindowProc(Wnd, Msg, wParam, lParam);

  WM_DROPFILES: begin
   DragQueryFile(wparam,0,@buffer,sizeof(buffer));
   LoadPic(buffer);
  end;

  WM_CREATE: begin
   But1:=CreateWindow('BUTTON', 'Open...', WS_CHILD
    or WS_VISIBLE or BS_PUSHLIKE,b1x,b1y,b1w,b1h,Wnd,0,hInstance,nil);
   SendMessage(But1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   But2:=CreateWindow('BUTTON','Save...',WS_CHILD or WS_DISABLED
    or WS_VISIBLE or BS_PUSHLIKE,b2x,b2y,b2w,b2h,Wnd,0,hInstance,nil);
   SendMessage(But2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   But3:=CreateWindow('BUTTON','Process',WS_CHILD or WS_DISABLED or BS_DEFPUSHBUTTON
    or WS_VISIBLE or BS_PUSHLIKE,b3x,b3y,b3w,b3h,Wnd,0,hInstance,nil);
   SendMessage(But3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed1:=CreateWindow('EDIT','0',WS_CHILD                 //  
    or WS_VISIBLE,e1x,e1y,e1w,e1h,Wnd,0,hInstance,nil);
   SendMessage(ed1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed2:=CreateWindow('EDIT','0',WS_CHILD or ES_NUMBER        // R
    or WS_VISIBLE,e2x,e2y,e2w,e2h,Wnd,0,hInstance,nil);
   SendMessage(ed2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed3:=CreateWindow('EDIT','0',WS_CHILD or ES_NUMBER        // G
    or WS_VISIBLE,e3x,e3y,e3w,e3h,Wnd,0,hInstance,nil);
   SendMessage(ed3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed4:=CreateWindow('EDIT','0',WS_CHILD or ES_NUMBER        // B
    or WS_VISIBLE,e4x,e4y,e4w,e4h,Wnd,0,hInstance,nil);
   SendMessage(ed4,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed5:=CreateWindow('EDIT','0',WS_CHILD                  //Centre X
    or WS_VISIBLE,e5x,e5y,e5w,e5h,Wnd,0,hInstance,nil);
   SendMessage(ed5,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed6:=CreateWindow('EDIT','0',WS_CHILD                   //Centre Y
    or WS_VISIBLE,e6x,e6y,e6w,e6h,Wnd,0,hInstance,nil);
   SendMessage(ed6,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed7:=CreateWindow('EDIT','1',WS_CHILD                   //Scale X
    or WS_VISIBLE,e7x,e7y,e7w,e7h,Wnd,0,hInstance,nil);
   SendMessage(ed7,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed8:=CreateWindow('EDIT','1',WS_CHILD                   //Scale Y
    or WS_VISIBLE,e8x,e8y,e8w,e8h,Wnd,0,hInstance,nil);
   SendMessage(ed8,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed9:=CreateWindow('EDIT','0',WS_CHILD                   //Shift X
    or WS_VISIBLE,e9x,e9y,e9w,e9h,Wnd,0,hInstance,nil);
   SendMessage(ed9,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ed10:=CreateWindow('EDIT','0',WS_CHILD                   //Shift Y
    or WS_VISIBLE,e10x,e10y,e10w,e10h,Wnd,0,hInstance,nil);
   SendMessage(ed10,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   ch1:=CreateWindow('BUTTON','CW',WS_CHILD or BS_RADIOBUTTON
    or WS_VISIBLE,c1x,c1y,c1w,c1h,Wnd,0,hInstance,nil);
   SendMessage(ch1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));
   SendMessage(ch1,BM_SETCHECK,BST_CHECKED,0);

   ch2:=CreateWindow('BUTTON','CCW',WS_CHILD or BS_RADIOBUTTON
    or WS_VISIBLE,c2x,c2y,c2w,c2h,Wnd,0,hInstance,nil);
   SendMessage(ch2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));
   SendMessage(ch2,BM_SETCHECK,BST_UNCHECKED,0);

   l2:=CreateWindow('STATIC','Calculation time (sec):'+#10+#13+'0',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l2x,l2y,l2w,l2h,Wnd,0,hInstance,nil);
   SendMessage(l2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l3:=CreateWindow('STATIC','Background color:',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l3x,l3y,l3w,l3h,Wnd,0,hInstance,nil);
   SendMessage(l3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l1:=CreateWindow('STATIC','Angle =',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l1x,l1y,l1w,l1h,Wnd,0,hInstance,nil);
   SendMessage(l1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l5:=CreateWindow('STATIC','R = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l5x,l5y,l5w,l5h,Wnd,0,hInstance,nil);
   SendMessage(l5,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l6:=CreateWindow('STATIC','G = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l6x,l6y,l6w,l6h,Wnd,0,hInstance,nil);
   SendMessage(l6,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l7:=CreateWindow('STATIC','B = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l7x,l7y,l7w,l7h,Wnd,0,hInstance,nil);
   SendMessage(l7,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l8:=CreateWindow('STATIC','Centre X = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l8x,l8y,l8w,l8h,Wnd,0,hInstance,nil);
   SendMessage(l8,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l9:=CreateWindow('STATIC','Centre Y = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l9x,l9y,l9w,l9h,Wnd,0,hInstance,nil);
   SendMessage(l9,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l10:=CreateWindow('STATIC','Scale X = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l10x,l10y,l10w,l10h,Wnd,0,hInstance,nil);
   SendMessage(l10,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l11:=CreateWindow('STATIC','Scale Y = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l11x,l11y,l11w,l11h,Wnd,0,hInstance,nil);
   SendMessage(l11,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l12:=CreateWindow('STATIC','Shift X = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l12x,l12y,l12w,l12h,Wnd,0,hInstance,nil);
   SendMessage(l12,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   l13:=CreateWindow('STATIC','Shift Y = ',WS_CHILD or SS_LEFT
    or WS_VISIBLE,l13x,l13y,l13w,l13h,Wnd,0,hInstance,nil);
   SendMessage(l13,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

   SetFocus(But1);
   result:=0;
  end;

  WM_DESTROY:begin
   DeleteObject(hFontBold);
   unregisterclass('PrecisRSSClass',hinstance);
   sour.Free;
   resb.Free;
   res2b.Free;
   postquitmessage(0);
  end;

  WM_SIZE: begin
   if init then begin
    GetClientRect(mainwnd,R);
    if origin then begin  //   
     if ((r.Right-1-(otX+sour.Width))<0)or(r.Bottom-1-((otY+sour.Height))<0) then begin   //   
      if (sour.Height/sour.Width)<((r.Bottom-otY-1)/(r.Right-otX-1)) then begin  //   ,  y -  
       picW:=r.Right-otX-1;
       picH:=doedin(picW*sour.Height/sour.Width);
      end else begin      // y  ,  x -  
       picH:=r.Bottom-otY-1;
       picW:=doedin(picH*sour.Width/sour.Height);
      end;
     end else begin
      picW:=sour.Width;
      picH:=sour.Height;
     end;
    end else begin    //   
     if ((r.Right-1-(otX+FinBit^.Width))<0)or((r.Bottom-1-(otY+FinBit^.Height))<0) then begin   //   
      if (FinBit^.Height/FinBit^.Width)<((r.Bottom-otY-1)/(r.Right-otX-1)) then begin  //   ,  y -  
       picW:=r.Right-otX-1;
       picH:=doedin(picW*FinBit^.Height/FinBit^.Width);
      end else begin      // y  ,  x -  
       picH:=r.Bottom-otY-1;
       picW:=doedin(picH*FinBit^.Width/FinBit^.Height);
      end;
     end else begin
      picW:=FinBit^.Width;
      picH:=FinBit^.Height;
     end;
    end;
   end;
   sendmessage(mainwnd,WM_PAINT,0,0);
   result:=0;
  end;

  WM_PAINT: begin
   GetClientRect(mainwnd,R);
   r.Left:=r.Left+otX+picW;
   InvalidateRect(mainwnd,@R,true);
   GetClientRect(mainwnd,R);
   r.Left:=r.Left+otX;
   r.top:=r.top+otY+picH;
   InvalidateRect(mainwnd,@R,true);
   BeginPaint(wnd,pst);
   d1:=getdc(mainwnd);
   SetStretchBltMode(d1,HALFTONE);
   if origin then StretchBlt(d1,otX,otY,picW,picH,sour.Canvas.Handle,0,0,sour.Width,sour.Height,srccopy)
             else StretchBlt(d1,otX,otY,picW,picH,FinBit^.Canvas.Handle,0,0,FinBit^.Width,FinBit^.Height,srccopy);
   releasedc(mainwnd,d1);
   Endpaint(wnd,pst);
   result:=0;
  end;

  WM_NCHITTEST:begin
                Result:=DefWindowProc(wnd,msg,wparam,lparam);
                if Result=HTCLIENT then Result:=HTCAPTION;
               end;

  WM_GETMINMAXINFO: begin
   PMinMaxInfo(LParam)^.ptMinTrackSize.X:=600; //   
   PMinMaxInfo(LParam)^.ptMinTrackSize.Y:=420; //   
   result:=0;
  end;                   

 else
  Result:=DefWindowProc(Wnd, Msg, wParam, lParam);
 end;
end;

BEGIN
 hFontBold:=CreateFont(8,0,0,0,0,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,0,'MS Sans Serif');
 WC.lpfnWndProc:=@WindowProc;
 WC.hicon:=loadicon(hinstance,'MAINICON');
 WC.hCursor:=LoadCursor(0,idc_arrow);
 WC.hbrBackground:=5;
 WC.lpszClassName:='PrecisRSSClass';
 RegisterClass(WC);
 systemparametersinfo(spi_getworkarea, 0, @grt, 0);
 MainWND:=CreateWindow('PrecisRSSClass',' RSSUtil',WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_SIZEBOX,
       (grt.Right-grt.Left-950) div 2,40,950,625,0,0,hInstance, nil);
 DragAcceptFiles(MainWND, True);      
 sour:=tbitmap.Create;
 resb:=tbitmap.Create;   
 res2b:=tbitmap.Create;

 While GetMessage(Mesg,0,0,0) do begin
  TranslateMessage(Mesg);
  if (Mesg.message=WM_CHAR)and(mesg.wParam=13)and init then sendmessage(mainwnd,WM_COMMAND,BN_CLICKED,but3);
  DispatchMessage(Mesg);
 end;
END.
